/*
 *  GUI Designed by : David Ekholm, Datadosen
 */

#define GetStr( g )      ((( struct StringInfo * )g->SpecialInfo )->Buffer  )
#define GetNumber( g )      ((( struct StringInfo * )g->SpecialInfo )->LongInt )

#define USE_MODE 0
#define DESIGN_MODE 1

extern struct IntuitionBase *IntuitionBase;
extern struct GfxBase            *GfxBase;
extern struct Library       *GadToolsBase;

extern struct Screen        *Scr;
extern APTR                  VisualInfo;
extern struct IntuiMessage   DB_Msg;
extern UWORD                 DB_Zoom[4];
extern struct TextAttr      *Font, Attr, UserTextAttr;
extern UWORD                 FontX, FontY;
extern UWORD                 OffX, OffY;
extern struct NewMenu        DB_NewMenu[];

extern struct Gadget        *LastGad;
extern BOOL ReactivateGad;
extern BOOL GadDoubleClicked;

extern void VisFldSelected(struct Gadget *gad);
extern void DragGadgetSelected(void);

extern int DB_NEW( void );
extern int DB_OPEN( void );
extern int DB_RELOAD( void );
extern int DB_SAVE( void );
extern int DB_SAVEAS( void );
extern int DB_OUTPUT_VIEW( void );
extern int DB_OUTPUT_VIEW_WN( void );
extern int DB_OUTPUT_TAB_ASCII( void );
extern int DB_OUTPUT_COMMA_ASCII( void );
extern int DB_ABOUT( void );
extern int DB_QUIT( void );
extern int DB_CUT( void );
extern int DB_COPY( void );
extern int DB_PASTE( void );
extern int DB_ADD( void );
extern int DB_KILL( void );
extern int DB_VIEW( void );
extern int DB_FIND( void );
extern int DB_FINDNEXT( void );
extern int DB_SORT( void );
extern int DB_DIAL( void );
extern int DB_BROWSE( void );
extern int DB_WARNINGS( void );
extern int DB_AZ( void );
extern int DB_ZA( void );
/* extern int DB_SAVESETTINGS( void ); */

extern int DB_FIELD_DEFINITION( void );
extern int DB_VIEW_DESIGN( void );
extern int DB_AREXX( void );
extern int DB_EXECUTE_AREXX( void );
extern int DB_EXECUTE_AREXX_AGAIN( void );

extern int SetupScreen( void );
extern void CloseDownScreen( void );
extern int HandleDB_IDCMP(struct Layout *Lay);
extern int DB_CloseWindow( void );
extern int DB_NewSize( void );
extern int DB_MenuHelp( void );
extern int DB_MouseMove( void );
extern int DB_SpecialAction( BOOL async );
extern int DB_VanillaKey( void) ;
extern int DB_RawKey( void );

void CloseMenu(struct Pro *Pr);
int OpenMenu(struct Pro *Pr);
int OpenLayWin(struct Pro *Pr, struct Layout *Lay);
void CloseLayWin(struct Pro *Pr, struct Layout *Lay);

void DeleteAllGadgets(struct Layout *Lay, char mode);
int CalcAllPos(struct Pro *Pr, struct Layout *Lay, WORD *ww, WORD *wh);
int CreateAllGadgets(struct Pro *Pr, struct Layout *Lay, WORD ww, WORD wh, char mode);
int AttachAllGadgets(struct Layout *Lay, WORD ww, WORD wh, char mode);
