#ifndef INCLUDE_URLTYPE_H
#define INCLUDE_URLTYPE_H

#define __UF_UNRESERVED 0x01
#define __UF_URIC       0x02
#define __UF_PCHAR      0x04
#define __UF_REGNAME    0x08
#define __UF_USERINFO   0x10
#define __UF_RELATIVE   0x20
#define __UF_SCHEME     0x40
#define __UF_SPECIAL    0x80
#define __UF_NOTADOS    0x100

extern short __UrlType[256];

#define isndos(c)     ((__UrlType[((unsigned char)c)]) & ((short) __UF_NOTADOS))
#define isunres(c)    ((__UrlType[((unsigned char)c)]) & ((short) __UF_UNRESERVED))
#define isuric(c)     ((__UrlType[((unsigned char)c)]) & ((short) (__UF_UNRESERVED | __UF_URIC)))
#define ispchar(c)    ((__UrlType[((unsigned char)c)]) & ((short) (__UF_UNRESERVED | __UF_PCHAR)))
#define isregname(c)  ((__UrlType[((unsigned char)c)]) & ((short) (__UF_UNRESERVED | __UF_REGNAME)))
#define isuserinfo(c) ((__UrlType[((unsigned char)c)]) & ((short) (__UF_UNRESERVED | __UF_USERINFO)))
#define isscheme(c)   ((__UrlType[((unsigned char)c)]) & ((short) __UF_SCHEME))
#define isrelurl(c)   ((__UrlType[((unsigned char)c)]) & ((short) (__UF_UNRESERVED | __UF_RELATIVE)))
#define isufmask(c,mask) ((__UrlType[((unsigned char)c)]) & ((short) mask))

#endif
