#ifndef HTTP_CLIENT_H
#define HTTP_CLIENT_H

enum { OPTIONS=0, GET, HEAD, POST, PUT, DELETE, TRACE };


struct http_url
{
  struct URLNode *und;          //For Compatibility....
  struct preferences *prefs;
  struct proj_prefs  *pprefs;
  struct parseurl    *pu;


  STRPTR url;
  STRPTR auth;
  STRPTR passwd;
  STRPTR referer;

  int sd;
  int port;
  int method;

  STRPTR service;
  STRPTR host;
  STRPTR path;
  STRPTR searchpath;

  STRPTR filename;
  STRPTR type;

  ULONG size;
  ULONG fsize;
  ULONG msize;
  ULONG rec;

  struct AsyncFile *fileout;
  struct FileInfoBlock *fib;
  struct DateStamp ds;

  LONG  httpver,
         httprev;

  STRPTR etag;
  STRPTR redirect;
  BOOL   connection;
  BOOL   chunked;
  LONG   chunksize;

  ULONG  status;
};




#endif
