/* Headerfile for the Rexx support for db */

#include <exec/types.h>
#include <exec/memory.h>
#include <exec/ports.h>
#include <rexx/rxslib.h>
#include <rexx/storage.h>
#include <rexx/errors.h>

extern struct MsgPort *MyRexxPort;
extern char MyRexxPortName[];	/* Enough for name and trailing numbers */


/* Functions you may call */

struct MsgPort *SetupRexxPort(char *basename);
void CloseRexxPort(struct MsgPort *rexxport);

BOOL SendRexxCommand(char *name);
BOOL SendRexxStrCommand(char *name);
BOOL HandleRexxMessage(struct MsgPort *rexxport);
