/* Private include file for the Select "class" */

#include "Select.h"

#define GetString( g )      ((( struct StringInfo * )g->SpecialInfo )->Buffer  )
#define GetNumber( g )      ((( struct StringInfo * )g->SpecialInfo )->LongInt )

#define GD_SELLview   0
#define GD_SELLadd    1
#define GD_SELLdel    2

/* Rawkeycodes + 128 for upkey codes */
#define RAW_TAB             (0x42)
#define RAW_ESC             (0x45)
#define RAW_HELP            (0x5f)

#define RAW_UP              (0x4c)
#define RAW_DOWN            (0x4d)
#define RAW_LEFT            (0x4f)
#define RAW_RIGHT           (0x4e)

#define VANILLA_DEL         (0x7f)
#define VANILLA_ESC         (0x1b)

static int SELLviewClicked(Select *);
static int SELLaddClicked(Select *);
static int SELLdelClicked(Select *);
static int SELOkClicked(Select *);
static int SELCancelClicked(Select *);
static int SelCloseWindow(Select *);
static int SelNewSize(Select *);
static int SelVanillaKey(Select *);
static int SelRawKey(Select *);
