//#define MYDEBUG
#define DEBUGLEVEL2
#define DEBUGDELAY  0

#ifdef MYDEBUG                  /* Turn on first level debugging */

#ifdef __cplusplus
extern "C"
{
#endif
  extern ULONG kprintf (char *,...);
#ifdef __cplusplus
}
#endif

#define D(x)  (x); if(DEBUGDELAY>0) Delay(DEBUGDELAY)
#define DD(x) (x); Delay(DDEBUGDELAY)
#define DQ(x) (x)

#ifdef DEBUGLEVEL2              /* Turn on second level debugging */
#define D2(x)  (x); if(DEBUGDELAY>0) Delay(DEBUGDELAY)
#define DD2(x) (x); Delay(DDEBUGDELAY)
#define DQ2(x) (x)
#else                           /* Second level debugging turned off */
#define D2(x) ;
#define DD2(x) ;
#define DQ2(x) ;
#endif                          /* DEBUGLEVEL2 */

#else /* First level debugging turned off */
#define D(x) ;
#define DQ(x) ;
#define D2(x) ;
#define DD(x) ;
#endif
